'disassembler for the 8085.
'
'Written by khorton@tech.iupui.edu
'
'I needed a disassembler, so I wrote this thing.  It works pretty
'good for a qbasic program.




'INSTRUCTIONS:


A0$ = "NOP@LXI B,@STAX B@INX B@INR B@DCR B@MVI B,@RLC@"
A1$ = "???@DAD B@LDAX B@DCX B@INR C@DCR C@MVI C,@RRC@"
A2$ = "???@LXI D,@STAX D@INX D@INR D@DCR D@MVI D,@RAL@"
A3$ = "???@DAD D@LDAX D@DCX D@INR E@DCR E@MVI E,@RAR@"
A4$ = "RIM@LXI H,@SHLD @INX H@INR H@DCR H@MVI H,@DAA@"
A5$ = "???@DAD H@LHLD @DCX H@INR L@DCR L@MVI L,@CMA@"
A6$ = "SIM@LXI SP,@STA @INX SP@INR M@DCR M@MVI M,@STC@"
A7$ = "???@DAD SP@LDA @DCX SP@INR A@DCR A@MVI A,@CMC@"
A8$ = "MOV B,B@MOV B,C@MOV B,D@MOV B,E@MOV B,H@MOV B,L@MOV B,M@MOV B,A@"
A9$ = "MOV C,B@MOV C,C@MOV C,D@MOV C,E@MOV C,H@MOV C,L@MOV C,M@MOV C,A@"
AA$ = "MOV D,B@MOV D,C@MOV D,D@MOV D,E@MOV D,H@MOV D,L@MOV D,M@MOV D,A@"
AB$ = "MOV E,B@MOV E,C@MOV E,D@MOV E,E@MOV E,H@MOV E,L@MOV E,M@MOV E,A@"
AC$ = "MOV H,B@MOV H,C@MOV H,D@MOV H,E@MOV H,H@MOV H,L@MOV H,M@MOV H,A@"
AD$ = "MOV L,B@MOV L,C@MOV L,D@MOV L,E@MOV L,H@MOV L,L@MOV L,M@MOV L,A@"
AE$ = "MOV M,B@MOV M,C@MOV M,D@MOV M,E@MOV M,H@MOV M,L@HLT@MOV M,A@"
AF$ = "MOV A,B@MOV A,C@MOV A,D@MOV A,E@MOV A,H@MOV A,L@MOV A,M@MOV A,A@"
B0$ = "ADD B@ADD C@ADD D@ADD E@ADD H@ADD L@ADD M@ADD A@"
B1$ = "ADC B@ADC C@ADC D@ADC E@ADC H@ADC L@ADC M@ADC A@"
B2$ = "SUB B@SUB C@SUB D@SUB E@SUB H@SUB L@SUB M@SUB A@"
B3$ = "SBB B@SBB C@SBB D@SBB E@SBB H@SBB L@SBB M@SBB A@"
B4$ = "ANA B@ANA C@ANA D@ANA E@ANA H@ANA L@ANA M@ANA A@"
B5$ = "XRA B@XRA C@XRA D@XRA E@XRA H@XRA L@XRA M@XRA A@"
B6$ = "ORA B@ORA C@ORA D@ORA E@ORA H@ORA L@ORA M@ORA A@"
B7$ = "CMP B@CMP C@CMP D@CMP E@CMP H@CMP L@CMP M@CMP A@"
B8$ = "RNZ@POP B@JNZ @JMP @CNZ @PUSH B@ADI @RST 0@"
B9$ = "RZ@RET@JZ @???@CZ @CALL @ACI @RST 1@"
BA$ = "RNC@POP D@JNC @OUT @CNC @PUSH B@SUI @RST 2@"
BB$ = "RC@???@JC @IN @CC @???@SBI @RST 3@"
BC$ = "RPO@POP H@JPO @XTHL@CPO @PUSH H@ANI @RST 4@"
BD$ = "RPE@PCHL@JPE @XCHG@CPE @???@XRI @RST 5@"
BE$ = "RP@POP PSW@JP @DI@CP @PUSH PSW@ORI @RST 6@"
BF$ = "RM@SPHL@JM @EI@CM @???@CPI @RST 7@"
A$ = A0$ + A1$ + A2$ + A3$ + A4$ + A5$ + A6$ + A7$
A$ = A$ + A8$ + A9$ + AA$ + AB$ + AC$ + AD$ + AE$ + AF$
A$ = A$ + B0$ + B1$ + B2$ + B3$ + B4$ + B5$ + B6$ + B7$
A$ = A$ + B8$ + B9$ + BA$ + BB$ + BC$ + BD$ + BE$ + BF$


'ADDRESSING MODES:
'0- NO DATA FOLLOWS
'1- 8-BIT DATA FOLLOWS
'2- 16-BIT DATA FOLLOWS
'    0 1 2 3 4 5 6 7 8 9 A B C D E F 0 1 2 3 4 5 6 7 8 9 A B C D E F
DATA 0,2,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,1,0
DATA 0,2,2,0,0,0,1,0,0,0,2,0,0,0,1,0,0,2,2,0,0,0,1,0,0,0,2,0,0,0,1,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,2,2,2,0,1,0,0,0,2,0,2,2,1,0,0,0,2,1,2,0,1,0,0,0,2,1,2,0,1,0
DATA 0,0,2,0,2,0,1,0,0,0,2,0,2,0,1,0,0,0,2,0,2,0,1,0,0,0,2,0,2,0,1,0



'READ IN ALL THE JUNK

DIM INSTRUCT$(256), ADDMODE(256), VARNAME$(255), VARVAL(255)
DIM HIGHESTVAR(20), VARCHAR(20), LABNAME$(255), LABLOC(255)
FOR A = 0 TO 255
READ ADDMODE(A)
NEXT

N = 0
FOR A = 1 TO LEN(A$)
B$ = MID$(A$, A, 1)
C$ = C$ + B$: IF B$ = "@" THEN INSTRUCT$(N) = LEFT$(C$, LEN(C$) - 1): C$ = "": N = N + 1
NEXT



INPUT "INPUT FILENAME"; FL$
INPUT "START ADD."; ST
INPUT "OUTPUT FILENAME"; FL2$
OPEN FL$ FOR BINARY AS 1
OPEN FL2$ FOR OUTPUT AS 2
LOOPA:

A$ = INPUT$(1, 1)
IF EOF(1) THEN END
INST = ASC(A$)
COLOR 7
PRINT USING "\  \"; HEX$(ST); "   ";
PRINT #2, USING "\  \"; HEX$(ST); "  ";
COLOR 3
PRINT INSTRUCT$(INST);
PRINT #2, INSTRUCT$(INST);
AM = ADDMODE(INST): ST = ST + 1
IF AM = 2 THEN ADDMD2 = ASC(INPUT$(1, 1)) + 256! * ASC(INPUT$(1, 1)): ST = ST + 2
IF AM = 2 THEN PRINT USING "\  \"; HEX$(ADDMD2);
IF AM = 2 THEN PRINT #2, USING "\  \"; HEX$(ADDMD2);
IF AM = 1 THEN ADDMD1 = ASC(INPUT$(1, 1)): ST = ST + 1
IF AM = 1 THEN PRINT USING "\\"; HEX$(ADDMD1);
IF AM = 1 THEN PRINT #2, USING "\\"; HEX$(ADDMD1);
PRINT
PRINT #2,
GOTO LOOPA

